package com.sipai.jspatrol.utils;

import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.SharedPreferences;
import android.content.pm.PackageInfo;
import android.content.pm.PackageManager;
import android.content.pm.PackageManager.NameNotFoundException;
import android.os.Build;
import android.os.Environment;
import android.os.Looper;
import android.util.Base64;
import android.util.Log;
import android.view.WindowManager;

import com.sipai.jspatrol.R;

import org.apache.http.protocol.HTTP;

import java.io.ByteArrayOutputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.io.Writer;
import java.lang.Thread.UncaughtExceptionHandler;
import java.lang.reflect.Field;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * UncaughtException处理类,当程序发生Uncaught异常的时候,有该类来接管程序,并记录发送错误报告.
 *
 * @author user
 *
 */
public class CrashHandler implements UncaughtExceptionHandler {

    public static final String TAG = "CrashHandler";

    //系统默认的UncaughtException处理类
    private UncaughtExceptionHandler mDefaultHandler;
    //CrashHandler实例
    private static CrashHandler INSTANCE = new CrashHandler();
    //程序的Context对象
    private Context mContext;
    //用来存储设备信息和异常信息
    private Map<String, String> infos = new HashMap<String, String>();

    //用于格式化日期,作为日志文件名的一部分
    private DateFormat formatter = new SimpleDateFormat("yyyy-MM-dd-HH-mm-ss");
    private HttpURLConnection conn;
    private URL url;
    /** 保证只有一个CrashHandler实例 */
    private CrashHandler() {
    }

    /** 获取CrashHandler实例 ,单例模式 */
    public static CrashHandler getInstance() {
        return INSTANCE;
    }

    /**
     * 初始化
     *
     * @param context
     */
    public void init(Context context) {
        mContext = context;
        //获取系统默认的UncaughtException处理器
        mDefaultHandler = Thread.getDefaultUncaughtExceptionHandler();
        //设置该CrashHandler为程序的默认处理器
        Thread.setDefaultUncaughtExceptionHandler(this);
    }

    /**
     * 当UncaughtException发生时会转入该函数来处理
     */
    @Override
    public void uncaughtException(Thread thread, Throwable ex) {
        if (!handleException(ex) && mDefaultHandler != null) {
            //如果用户没有处理则让系统默认的异常处理器来处理
            mDefaultHandler.uncaughtException(thread, ex);
        } else {
            try {
                Thread.sleep(15000);
            } catch (InterruptedException e) {
                Log.e(TAG, "error : ", e);
            }
            //退出程序
            android.os.Process.killProcess(android.os.Process.myPid());
            System.exit(1);
        }
    }

    /**
     * 自定义错误处理,收集错误信息 发送错误报告等操作均在此完成.
     *
     * @param ex
     * @return true:如果处理了该异常信息;否则返回false.
     */
    private boolean handleException(Throwable ex) {
        if (ex == null) {
            return false;
        }
        //使用Toast来显示异常信息
        new Thread() {
            @Override
            public void run() {
                Looper.prepare();
                sendAppCrashReport(mContext,"",null);
//                Toast.makeText(mContext, "很抱歉,程序出现异常,即将退出.", Toast.LENGTH_LONG).show();
                Looper.loop();
            }
        }.start();
        //收集设备参数信息
        collectDeviceInfo(mContext);
        //保存日志文件
        saveCrashInfo2File(ex);
        return true;
    }
    private void sendAppCrashReport(final Context context,
                                    final String crashReport, final File file) {
        AlertDialog.Builder builder = new AlertDialog.Builder(context)
                .setIcon(android.R.drawable.ic_dialog_info)
                .setTitle(R.string.app_error)
                .setMessage(R.string.app_error_msg)
                .setPositiveButton("确定",
                        new DialogInterface.OnClickListener() {
                            public void onClick(DialogInterface dialog, int which) {
//                                try {
//                                //发送报告到服务器
//
//                                } catch (Exception e) {
//                                } finally {
                                    dialog.dismiss();
                                    // 退出
                                    android.os.Process.killProcess(android.os.Process.myPid());
                                    System.exit(1);
//                                }
                            }
                        });
//                .setNegativeButton(android.R.string.cancel,
//                        new DialogInterface.OnClickListener() {
//                            public void onClick(DialogInterface dialog, int which) {
//                                dialog.dismiss();
//                                // 退出
//                                android.os.Process.killProcess(android.os.Process.myPid());
//                                System.exit(1);
//                            }
//                        });

        AlertDialog dialog = builder.create();
        //需要的窗口句柄方式，没有这句会报错的
        if (Build.VERSION.SDK_INT>=Build.VERSION_CODES.O){
            dialog.getWindow().setType(WindowManager.LayoutParams.TYPE_APPLICATION_OVERLAY);
        }else  {
            dialog.getWindow().setType(WindowManager.LayoutParams.TYPE_SYSTEM_ALERT);
        }
        dialog.show();
    }
    /**
     * 收集设备参数信息
     * @param ctx
     */
    public void collectDeviceInfo(Context ctx) {
        try {
            PackageManager pm = ctx.getPackageManager();
            PackageInfo pi = pm.getPackageInfo(ctx.getPackageName(), PackageManager.GET_ACTIVITIES);
            if (pi != null) {
                String versionName = pi.versionName == null ? "null" : pi.versionName;
                String versionCode = pi.versionCode + "";
                infos.put("versionName", versionName);
                infos.put("versionCode", versionCode);
            }
        } catch (NameNotFoundException e) {
            Log.e(TAG, "an error occured when collect package info", e);
        }
        Field[] fields = Build.class.getDeclaredFields();
        for (Field field : fields) {
            try {
                field.setAccessible(true);
                infos.put(field.getName(), field.get(null).toString());
                Log.d(TAG, field.getName() + " : " + field.get(null));
            } catch (Exception e) {
                Log.e(TAG, "an error occured when collect crash info", e);
            }
        }
    }

    /**
     * 保存错误信息到文件中
     *
     * @param ex
     * @return  返回文件名称,便于将文件传送到服务器
     */
    private String saveCrashInfo2File(Throwable ex) {

        StringBuffer sb = new StringBuffer();
        for (Map.Entry<String, String> entry : infos.entrySet()) {
            String key = entry.getKey();
            String value = entry.getValue();
            sb.append(key + "=" + value + "\n");
        }

        Writer writer = new StringWriter();
        PrintWriter printWriter = new PrintWriter(writer);
        ex.printStackTrace(printWriter);
        Throwable cause = ex.getCause();
        while (cause != null) {
            cause.printStackTrace(printWriter);
            cause = cause.getCause();
        }
        printWriter.close();
        String result = writer.toString();
        sb.append(result);
        try {
//            long timestamp = System.currentTimeMillis();
            String time = formatter.format(new Date());
            final String fileName = mContext.getResources().getString(R.string.appflag).toLowerCase()+"-crash-" + time  + ".txt";
            if (Environment.getExternalStorageState().equals(Environment.MEDIA_MOUNTED)) {
                final String  path = "/sdcard/crash/";
                File dir = new File(path);
                if (!dir.exists()) {
                    dir.mkdirs();
                }
                FileOutputStream fos = new FileOutputStream(path + fileName);
                fos.write(sb.toString().replaceAll("\n","\r\n").getBytes());
                fos.close();
                new Thread(new Runnable() {
                    @Override
                    public void run() {
//                        upFile(path,fileName);
                    }
                }).start();

            }
            return fileName;
        } catch (Exception e) {
            Log.e(TAG, "an error occured while writing file...", e);
        }
        return null;
    }
    private String upFile(String path,String filename) {


        ByteArrayOutputStream baos = null;
        String _path = null;
        try {
            //构建host的url地址
            SharedPreferences sharedPre=mContext.getSharedPreferences("config", Context.MODE_PRIVATE);
            String mServer=sharedPre.getString("server", "");
            String mBizid=sharedPre.getString("bizid", "");
            _path = path + filename;
            byte[] photoBytes=null;
            String BOUNDARY = "Boundary";
            String PREFIX = "--" , LINEND = "\r\n" ;
            String MULTIPART_FROM_DATA = "multipart/form-data" ;
            String CHARSET = "UTF-8" ;
            //要上传的参数
            String param = "&filename=" + URLEncoder.encode(filename, "UTF-8");
            param+="&bizid=" + URLEncoder.encode(mBizid, "UTF-8");
            //通过openConnection 连接
            url=new URL(mServer+"proapp.do?method=dosavelog"+param);
            conn=(HttpURLConnection)url.openConnection();
            //设置输入和输出流
            conn.setDoOutput(true);
            conn.setDoInput(true);
            conn.setRequestMethod("POST");
            conn.setUseCaches(false);
            conn.setRequestProperty("Connection", "Keep-Alive");
            conn.setRequestProperty("Charset", HTTP.UTF_8);
            conn.setRequestProperty ( "Content-Type" , MULTIPART_FROM_DATA+";boundary=" + BOUNDARY ) ;
            //HttpClient client = new DefaultHttpClient();
            conn.connect();
            baos = new ByteArrayOutputStream();
            File f=new File(_path);
            if(f.exists()){
					/* 取得文件的FileInputStream */
                FileInputStream fStream =new FileInputStream(_path);
			          /* 设置每次写入1024bytes */
                int bufferSize =1024;
                byte[] buffer =new byte[bufferSize];
                String bufferall="";
                int length =-1;
			          /* 从文件读取数据至缓冲区 */
                DataOutputStream out = new DataOutputStream (
                        conn.getOutputStream ( ) ) ;
                out.write("upLog ".getBytes());//标记图片流， 为与接口对应，需要在后面加空格
                while((length = fStream.read(buffer)) !=-1)
                {
			            /* 将资料写入DataOutputStream中 */

                    baos.write(buffer);

                }
                photoBytes=baos.toByteArray();
                out.write(Base64.encode(photoBytes, Base64.DEFAULT));
                //System.out.println(bufferall.getBytes(),Base64.DEFAULT).toString());
                //out.writeBytes(LINEND);
                out.writeBytes( PREFIX + BOUNDARY + PREFIX + LINEND);
                //				          OutputStream  out = conn.getOutputStream ( ) ;
                //				          out.write(Base64Coder.encodeLines(photoBytes).getBytes());
                //刷新、关闭
                out.flush();
                out.close();

            }


            if (HttpURLConnection.HTTP_OK  == conn.getResponseCode() ) {
//					System.out.println(conn.getContent());
//                Message message=Message.obtain();
//                message.what=SUCCESS;
//                myHandler.sendMessage(message);
                //						System.out.println("上传完成");

            } else {
//					cancelProgress();
                //						System.out.println("上传失败");
//                Message message=Message.obtain();
//                message.what=ERROR;
//                myHandler.sendMessage(message);
            }


        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            try {
                if (baos != null)
                    baos.close();
                if (conn != null) {
                    //		                conn.disconnect();
                }
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
        return _path;
    }
}